#include <stdio.h>
#include "stack.h"

bool getop(Stack* s, double* n1, double* n2)
{
 if(s->isEmpty())
 {
  printf("Empty stack!\n");
  return false;
 }
 *n2 = s->pop();
 if(s->isEmpty())
 {
  s->push(*n2);
  printf("Two operands needed!\n");
  return false;
 }
 *n1 = s->pop();
 return true;
}

void main()
{
 printf("Calculator RPN - Console\n");

 Stack stack;
 char string[20];
 double a;

 do 
 {
  printf("Enter with a number ('q' to quit): ");
  gets(string);
  if( sscanf(string, "%lf", &a) == 1 )
  {
   printf("Number: %f\n", a);

   stack.push(a);
  }
  else
  {
   double v1;
   double v2;
   double v3;
   switch(string[0])
   {
    case '+':
     if(getop(&stack, &v1, &v2))
     {
      v3 = v1 + v2;
      printf("Sum: %f\n", v3);
      stack.push(v3);
     }
     break;
    case '-':
     if(getop(&stack, &v1, &v2))
     {
      v3 = v1 - v2;
      printf("Diff: %f\n", v3);
      stack.push(v3);
     }
     break;
    case '*':
     if(getop(&stack, &v1, &v2))
     {
      v3 = v1 * v2;
      printf("Prod: %f\n", v3);
      stack.push(v3);
     }
     break;
    case '/':
     if(getop(&stack, &v1, &v2))
     {
      v3 = v1 / v2;
      printf("Div: %f\n", v3);
      stack.push(v3);
     }
     break;
    case 'q':
     break;
    default:
     printf("Input error!\n");
     break;
   }
  }
 } while (string[0] != 'q');

 stack.show();
}